Attribute VB_Name = "WinHelper"
Option Explicit

Public Function BindWebView(ByRef WidgetForm As cWidgetForm) As cWebView2
Dim ret As Long
Dim installPath As String
Dim fso As cFSO
Dim wv As cWebView2
    On Error GoTo BindWebView_Error
    Set fso = New_c.fso
    Set wv = New_c.WebView2
    WidgetForm.Move -1000, -1000, 1, 1
    WidgetForm.Show
    On Error Resume Next
    Do
        If Len(VW2Path) > 0 Then
            ret = wv.BindTo(WidgetForm.hwnd, 4, VW2Path, fso.GetLocalAppDataPath & "\" & App.ProductName, "--lang=de")
            If ret = 0 Then
                MsgBox "Die WiewView2 Komponente konnte nicht geladen werden!" & vbCrLf & _
                    "Die Anwendung versucht die WiewView2 EverGreen-Version zu verwenden.", vbInformation, App.ProductName
                ret = wv.BindTo(WidgetForm.hwnd, 4, , fso.GetLocalAppDataPath & "\" & App.ProductName, "--lang=de")
            End If
        Else
            ret = wv.BindTo(WidgetForm.hwnd, 4, , fso.GetLocalAppDataPath & "\" & App.ProductName, "--lang=de")
        End If

        If ret = 0 Then
            installPath = AppPath & IIf(App.LogMode, "", "Bin\") & "MicrosoftEdgeWebview2Setup.exe"
            If Len(wv.GetMostRecentInstallPath) = 0 And fso.FileExists(installPath) Then
                If MsgBox("Die WebView-Komponente konnte nicht initialisiert werden! " & _
                       "Vermutlich ist die WebView2-Runtime auf Ihrem System nicht installiert. " & _
                       "Mchten Sie die Runtime jetzt installieren?", vbQuestion + vbYesNo + vbDefaultButton1, "WebView2-Runtime installieren...") = vbYes Then
                    VW2Path = ""
                    If Not Installer.InstallWebView2(installPath) Then Exit Function
                Else
                    Exit Function
                End If
            Else
                MsgBox "Die WebView-Komponente konnte nicht initialisiert werden!", vbCritical, "Liquidittsplaner"
                Exit Function
            End If
        End If
    Loop While ret = 0
    On Error GoTo BindWebView_Error
    WidgetForm.Hide
    wv.IsStatusBarEnabled = False
    If Not (App.LogMode = 0 Or mMain.Debugger) Then
        wv.AreDefaultContextMenusEnabled = False
        wv.AreDevToolsEnabled = False
    End If
    Set BindWebView = wv
    
    Exit Function
    
BindWebView_Error:
    Err.Raise Err.Number, _
     "WinHelper.BindWebView." & Erl & vbCrLf & Err.Source, _
     vbCrLf & Err.Description
End Function

